<?xml version='1.0' encoding='UTF-8' ?>
<!--
  ~ Copyright (c) 2016 Roman Nazarenko.
  ~
  ~  This program is free software: you can redistribute it and/or modify
  ~  it under the terms of the GNU Affero General Public License as
  ~  published by the Free Software Foundation, either version 3 of
  ~  the License, or (at your option) any later version.
  ~
  ~  This program is distributed in the hope that it will be useful,
  ~  but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~  GNU General Public License for more details.
  ~
  ~  You should have received a copy of the GNU General Public License
  ~  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	  xmlns:h="http://xmlns.jcp.org/jsf/html"
	  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	  xmlns:f="http://xmlns.jcp.org/jsf/core"
	  xmlns:o="http://omnifaces.org/ui">

<h:head>
	<ui:include src="/WEB-INF/jsf/include/title.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/imports.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/init.xhtml"/>
</h:head>
<h:outputScript>

	$(function () {
		jsf.ajax.addOnEvent(function (event) {
			if (event.status === 'success') {
				registerMarkdownEditor();
			}
		});
		registerMarkdownEditor();
	});

	function registerMarkdownEditor() {
		$('#changeBioFormId\\:markdownTextArea').markdown({
			resize: 'vertical',
			height: 1200,
		});
	}

</h:outputScript>
<h:body styleClass="pushable">
	<div class="pusher">
		<div class="ui container framed">
			<ui:include src="/WEB-INF/jsf/include/header.xhtml"/>
			<div class="ui centered two columns footer-margin grid">
				<div class="ui eleven wide column">
					<div class="ui raised segment">
						<h2>Edit site owner bio</h2>
						<h:form id="changeBioFormId"
								styleClass="ui ${errorUtils.formClass(component)} form"
								enctype="multipart/form-data">
							<div class="ui divider"></div>
							<div class="ui centered two rows fluid stackable grid">
								<div class="ui two columns row">
									<div class="ui eleven wide column">
										<div class="field">
											<label>Site owner name</label>
											<h:inputText value="#{bioEditBean.ownerName}">
												<f:passThroughAttribute name="placeholder" value="Name"/>
											</h:inputText>
										</div>
										<div class="field">
											<label>Site owner nickname</label>
											<h:inputText value="#{bioEditBean.ownerNickname}">
												<f:passThroughAttribute name="placeholder" value="Nickname"/>
											</h:inputText>
										</div>
										<div class="field">
											<label>Site owner E-Mail</label>
											<h:inputText value="#{bioEditBean.ownerEmail}">
												<f:passThroughAttribute name="placeholder" value="E-Mail"/>
											</h:inputText>
										</div>
										<div class="field">
											<label>Site owner short description</label>
											<h:inputText value="#{bioEditBean.ownerDescription}">
												<f:passThroughAttribute name="placeholder" value="Description"/>
											</h:inputText>
										</div>
										<div class="ui success message">
											Changes successfully saved
										</div>
										<div class="ui error message">
											<div class="header">Error:</div>
											<h:messages showDetail="true" showSummary="false"/>
										</div>
									</div>
									<div class="ui five wide column">
										<div class="field">
											<label>Photo</label>
											<div class="image">
												<o:graphicImage value="${images.ownerPhoto}"
																alt="Photo"
																lastModified="${bioUtils.photoLastModified}"/>
											</div>
											<h:inputFile value="#{bioEditBean.photoPart}"
														 maxlength="${bioEditBean.maxPhotoSize()}"/>
										</div>
										<h:commandButton styleClass="ui primary button" value="Save"
														 action="#{bioEditBean.save}">
											<!--
												This is weird, but we must use AJAX here. The reason is a Wildfly 9 bug:
												its JSF engine throws a deprecated EvaluationException while it's
												built-in exception handler only checks newer ELException, making EL
												evaluation errors non-unwrappable and leading to 500 on any exception
												from the EL. OmniFaces' AJAX handler is not affected thus we'll stick
												to it until Wildfly is all-fixed and non-operable versions become obsolete.
											-->
											<f:ajax execute="@form" render=":changeBioFormId"/>
										</h:commandButton>
									</div>
								</div>
								<div class="ui one columns row">
									<div class="ui sixteen wide column">
										<div class="field">
											<label>Bio</label>
											<h:inputTextarea id="markdownTextArea"
															 value="#{bioEditBean.bio}"
															 validatorMessage="Content must not be empty">
												<f:validateRequired/>
											</h:inputTextarea>
										</div>
									</div>
								</div>
							</div>
						</h:form>
					</div>
				</div>
			</div>
		</div>
		<ui:include src="/WEB-INF/jsf/include/footer.xhtml"/>
	</div>
</h:body>
</html>

